Program shaprec;
{$X+ }
{$R- }
{$M 38467,0,655360 }

Uses Crt,VgaKern,MiscFunc,KeyBoard,Imaging,Gmorph,
     Beffects,OopObjs,Flics,Dsound,Joystick;

const
path = '';
piecewmax       =10;
piecehmax       =10;

var
piecenum        : Integer;
piecew          : Integer;
pieceh          : Integer;

type
  pshot= ^tshot;
  tshot = object(tobjs)
            ndx,ndy  : integer;
            constructor init;
            procedure drawitemobject;virtual;
            procedure calcitemobject;virtual;
            function checkhit(hx,hy:integer;var item:pobjs):boolean;virtual;
          end;

var
dummy           : integer;
oldexit         : pointer;
scp             : RGBlist;      {* standard color palette *}
rsmisc          : array[0..15] of pointer;

constructor tshot.init;
begin
  nx := 10; ny := 10; explo := false;
  ndy := 0; ndx := 0; id := false;
  nrx := 0; mapcolor := $fb; pointage := 0;
  flp := 0; timeo := 15; overshow := false;
end;

procedure tshot.drawitemobject;
begin
     fbitdraw(153,84,rsmisc[piecenum]^);
end;


procedure tshot.calcitemobject;
var
  p : plist;
begin
  if random<0.8
    then
      if (nrx<0) and (ndx>-15)
        then dec(ndx)
        else
         if (nrx>0) and (ndx<15)
           then inc(ndx);
  inc(nx,ndx); inc(ny,ndy); dec(timeo);
end;

function tshot.checkhit(hx,hy:integer;var item:pobjs):boolean;
begin
  checkhit := false;
end;

procedure setup;
begin
  clrscr;
  writeln('Welcome to the worlds fastest jigsaw puzzle solver.');
  writeln('Shape recognition program demo');
  writeln('By Aaron Wacker');
  writeln;
  writeln('Keys:');
  writeln('press space to search for another object');
  writeln('press esc to leave the program');
  writeln('press a combination of the shift keys and +/- to ');
  writeln('change the shape of the search template.');

  repeat until ch<>#1;
  loadvsp(path+'cany77.vsp',rsmisc);
  piecenum:=1;
  piecew:=5;
  pieceh:=5;
end;


procedure drawpage;
var
x,y           : Integer;

begin
  openmode(2);
  setpageactive(1);
  loadcolors(path+'canyon.pal',scp,255);
  fsetcolors(zdc);
  loadpcx(path+'canyon.pcx');
  fadein(50,zdc,scp);
end;

procedure drawmenubar;
begin
  bar(0,0,319,10,10);
  fbitdraw(0,0,rsmisc[piecenum]^);  {draw shape to be found}
end;

procedure scan;
var
x,y             : Integer;
piecex,
piecey          : Integer;   {position of pixel matching attempt}
pixelhit        : Integer;
bestpixyet      : Integer;   {most pixel hits found on a single try}
bestyetx,
bestyety        : Integer;   {piece pos with most pixelhits (color matches)}


begin
  bestpixyet:=0;        {we haven't tried to match pixels yet}
  for x:=0 to 319 do begin
      for y:=11 to 199 do begin  {11 because don't check menubar(1-10)}
         {reset pixelhit - trying out a new position for piece}
         pixelhit:=0;
         for piecex:=0 to piecew-1 do begin
           for piecey:=0 to pieceh-1 do begin
               if Point(x+piecex,y+piecey,1) = Point(piecex,piecey,1) then begin
                  pixelhit:=pixelhit+1;
                  if lshft and plus then if pieceh<piecehmax then pieceh:=pieceh+1;
                  if rshft and plus then if piecew<piecewmax then piecew:=piecew+1;
                  if lshft and minus then if pieceh>1 then pieceh:=pieceh-1;
                  if rshft and minus then if piecew>1 then piecew:=piecew-1;
                  bar(14,0,21,7,100);
                  bar(14,0,14+piecew,pieceh,90);
                  if esc then exit;
               end;
           end; {for piecex}
           if esc then exit;
         end; {for piecey}
         if esc then exit;
         if pixelhit>bestpixyet then begin
            bestpixyet:=pixelhit;
            bestyetx:=x;
            bestyety:=y;
         end; {if}
      end;
      if esc then exit;
  end; {for 0-319}
  if esc then exit;
  fbitdraw(bestyetx,bestyety,rsmisc[0]^);

end;


{** main **}
begin
     setup;
     drawpage;
     repeat
       piecenum:=piecenum+1;
       if piecenum>9 then piecenum:=0;
       drawmenubar;
       scan;
       delay(10);
       if space then exit;
     until esc;

     fadeout(50,scp,zdc);
     closemode;
end.