Program stars;
{ by Aaron Wacker }

{$X+ }
{$R- }
{$M 38467,0,655360 }


Uses Crt,VgaKern,MiscFunc,KeyBoard,Imaging,
     Gmorph,Beffects,OopObjs,Flics,Dsound,Mouse;

const
   path    = '';
   visible     : boolean = True;   { TRUE if mouse cursor is visible }
   mousehere   : boolean = false;   { TRUE if the mouse drv is here }
   mousewason  : boolean = false;   { TRUE is mouse was on from last MOUSEOFF call }
   mouseoncall : boolean = false;   { TRUE if last call was MOUSEON, MOUSEOFF }
   skl         : integer = 1;       { Scale value for X,  some mouse drivers }

type
  data1 = record
            safe,flip,
            vdx,vdy,guys,
            vx,vy,drx    : integer;
            lvls         : array[0..2] of integer;
            score        : longint;
            turn,blown   : boolean;
          end;
  pshot= ^tshot;
  tshot = object(tobjs)
            ndx,ndy  : integer;               {velocity along x and y}
            constructor init;                 {make the object}
            procedure drawitemobject;virtual; {draw it}
            procedure calcitemobject;virtual; {move it and do other calc}
            function checkhit(hx,hy:integer;var item:pobjs):boolean;virtual;
          end;
  pmine= ^tmine;
  tmine = object(tobjs)
            ndx,ndy  : integer;
            spritenum : integer;
            constructor init;
            procedure drawitemobject;virtual;
            procedure calcitemobject;virtual;
            function checkhit(hx,hy:integer;var item:pobjs):boolean;virtual;
          end;
  pbutton= ^tbutton;
  tbutton = object(tobjs)
            ndx,ndy  : integer;
            btnx,btny  : integer;
            btnnum     : integer;
            state      : integer;
            constructor init;
            procedure drawitemobject;virtual;
            procedure calcitemobject;virtual;
            function checkhit(hx,hy:integer;var item:pobjs):boolean;virtual;
          end;

var
   ctr,
   ypos  :integer;
   nkbeg,nkend   : plist;
   rsmisc        : array[0..39] of pointer;
   kill          : pkill;
   mx,my         : Integer;
   vmx,vmy       : Integer;
   player        : data1;
   ovx,ovy,gx,gy : integer;
   mdown         : integer;
   placex, placey : integer;    { use for placing objects }
   placetype      : integer;
   placeframes    : integer;    { number of flip frames the placed ob has}
   dac           : RGBlist;

procedure setparms;
var
  d : integer;
  p : plist;
begin
  kill := nil;
  nkbeg := nil; nkend := nil;
end;

procedure calcitems;
var
  p : plist;
begin
  p := nkbeg;
  while p<>nil do
    begin
      p^.item^.calcitemobject;
      p := p^.next;
    end;
end;

procedure drawitems(over:boolean);
var
  p : plist;
begin
  p := nkbeg;
  while p<>nil do
    begin
      if (p^.item^.overshow=over)
        then p^.item^.drawitemobject;
      p := p^.next;
    end;
end;

procedure drawstatus;
var
  xp : integer;
begin
  with player do
    begin
     bar(10,180,12,180-player.score,5); {show kills}
    end;
end;

procedure addfire;
var
  p : plist;
begin
  new(p);
  p^.item := new(pshot,init);
  p^.item^.powner := p;
  addp(nkbeg,nkend,p);
end;

procedure addmines(minenum: Integer);
var
  p : plist;
  mines     : Integer;
begin
for mines:=1 to minenum do begin
    new(p);
    p^.item := new(pmine,init);
    p^.item^.powner := p;
    addp(nkbeg,nkend,p);
  end;
end;

procedure addbutton;
var
  p : plist;
  mines     : Integer;
begin
    new(p);
    p^.item := new(pbutton,init);
    p^.item^.powner := p;
    addp(nkbeg,nkend,p);
end;

procedure addallbuttons;
begin
     placex:=1; placey:=25; placetype:=0; placeframes:=2;
     addbutton;
     placex:=1; placey:=55; placetype:=2; placeframes:=2;
     addbutton;
     placex:=1; placey:=85; placetype:=4; placeframes:=2;
     addbutton;
     placex:=1; placey:=115; placetype:=6; placeframes:=2;
     addbutton;

end;

procedure initmouse;
begin
     setdefptr;
     setmouseratio(1,1);
     if mousereset=0 then mouseon;
     setmouse(160,105);
end;

procedure updatemouse;
var vx,vy : Integer;
    x,y   : Integer;
    button: Integer;

begin
     getmouse(button,x,y);
     setdefptr;
     if boolean(button and 1)=true then addfire;
     if boolean(button = 2)=true then addmines(5);
       fbitdraw(x,y,rsmisc[10]^);
     getmousemotion(vx,vy);
     x:=x+round(vx*1.5);
     y:=y+round(vy*1.5);
     mx:=x;
     my:=y;
     vmx:=vx;
     vmy:=vy;
     mdown:=button;
end;

function checkallhit(hx,hy:integer;item:pobjs) : boolean;
var
  p   : plist;
  did : boolean;
begin
  p := nkbeg; did := false;
  while (p<>nil) and not did do
    begin
      if p^.item^.id    { shots don't affect eachother (id=0) }
        then did := p^.item^.checkhit(hx,hy,item);
      p := p^.next;
    end;
  checkallhit := did;
end;


(**) { tshot Methods }
constructor tshot.init;
begin
  nx := mx; ny := my; explo := false;  {x,y = mousex,y  not exploding yet}
  ndy := vmy; ndx := vmx; id := false; {vel x,y = mouse vx,vy  id-test self collide}
  nrx := 2; mapcolor := $fb; pointage := 0; {mapcolor is for radar display}
  flp := 0; timeo := 25; overshow := false; {flp-1 frame  timeo-timeout}
end;
procedure tshot.drawitemobject;
begin
       fbitdraw(nx,ny,rsmisc[26]^); {draw sprite masking black pixels}
end;
procedure tshot.calcitemobject;
var
  p : plist;
begin
  {change location}
  inc(nx,ndx); inc(ny,ndy);
  dec(timeo);  {shots don't keep going}
  if (timeo=0) or (nx<0) or (ny<0) or (nx>310) or (ny>195)
    then add2kill_list(kill,powner)   {delete later on}
    else
      if checkallhit(nx,ny,@self)     {if it hits something, the shot dies}
        then add2kill_list(kill,powner);
end;
function tshot.checkhit(hx,hy:integer;var item:pobjs):boolean;
begin
  checkhit := false;
end;

(**) { tmine Methods }
constructor tmine.init;
var whichway           : integer;
begin
  nx := random(300); ny := random(180); explo := false;
  whichway:=random(2);
  if whichway=1 then whichway:=-1 else whichway:=1;
  ndy := whichway*(random(2)+1); ndx := whichway*(random(2)+1); id:=true;
  nrx := 2; mapcolor := $fb; pointage := 2;
  flp := 0; overshow := false;
  spritenum:=random(8)+12;
end;
procedure tmine.drawitemobject;
begin
       fbitdraw(nx,ny,rsmisc[spritenum]^);
end;
procedure tmine.calcitemobject;
var
  p : plist;
begin
  inc(nx,ndx); inc(ny,ndy);
  {reverse direction if going off screen}
  if (nx<10) then ndx:=abs(ndx) else if (nx>300) then ndx:=-abs(ndx);
  if (ny<10) then ndy:=abs(ndy) else if (ny>180) then ndy:=-abs(ndy);
end;
function tmine.checkhit(hx,hy:integer;var item:pobjs):boolean;
begin
  if not explo and range(hx,hy,nx,ny,nx+12,ny+24) {range is col detect}
    then
      begin
        explo := true; {will be an explosion sequence later}
        checkhit := true;                {the mine has been hit!}
        inc(player.score,pointage);      {this stuff is for later}
        add2kill_list(kill,powner);      {delete this object later}
      end
    else checkhit := false;
end;

(**) { tbutton Methods }
constructor tbutton.init;
begin
  explo := false;
  btnx:=placex; btny:=placey;
  btnnum:=placetype;
  num_sprite:=placeframes;
  ndy := 0; ndx := 0; id:=true;
  nrx := 2; mapcolor := $fb; pointage := 2;
  flp := 0; overshow := false;
  state:=1;
end;
procedure tbutton.drawitemobject;
begin
       fbitdraw(btnx,btny,rsmisc[btnnum+flp]^);
end;
procedure tbutton.calcitemobject;
var
  p : plist;
begin    {don't move buttons}
   if explo=true then begin
     if not boolean(mdown and 1) then begin   {wait til the button is back up }
        {inc(flp,1);}
        if flp=1 then flp:=0 else flp:=1;
        {if (flp>num_sprite) then begin}
        {  flp:=0;  }
           explo:=false;
        {end;}
     end;
   end;
end;
function tbutton.checkhit(hx,hy:integer;var item:pobjs):boolean;
begin
  if not explo and range(mx,my,btnx,btny,btnx+12,btny+24) and
       boolean(mdown and 1)=true
 {range is col detect}
    then
      begin
        state:=-state;
        explo:=true;    {explosion is the cycling of frames}
        checkhit := true;                {the mine has been hit!}
        {add2kill_list(kill,powner);}      {delete this object later}
      end
    else checkhit := false;
end;

procedure setup;
begin
  randomize;
  initmouse;
  setparms;
  player.score:=0;

  clearbuffer;
  clrscr;
  openmode(3);

  fsetcolors(zdc);
  setpageactive(3);
  loadpcx(path+'stars.pcx');                {load a background pic}
  loadcolors(path+'buttons.pal',dac,255);
  loadvsp(path+'btnsbls.vsp',rsmisc);        {load a sprite file}

  pcopy(3,1);
  fadein(200,zdc,dac);
end;

begin
  setup;
  addallbuttons;
  addmines(20);
  repeat
   pcopy(3,2);
   setpageactive(2);
   updatemouse;
   calcitems;
   cleankill_list(kill,nkbeg,nkend);
   drawitems(false);
   drawstatus;
   pcopy(2,1);
  until space;

  closemode;
end.
